
!FLMetalevelFactory methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:49'!
compiledMethods

	| methods |
	methods := self fewSystemClasses inject: Array new into: [ :array :aClass | array, aClass methodDict values ].
	
	^ (1 to: self problemSize)
		collect: [ :i | (methods atWrap: i) copy ]
! !

!FLBasicSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/26/2013 23:21'!
expectedFailures
	| failures minorVersion |
	failures := #(testConsiderCustomWideSymbolGlobal).
	minorVersion := (SystemVersion current version findTokens: 'Squeak') first last. 
	minorVersion asInteger < 3 ifTrue: [ 
		failures := failures, #(testSetElement testSetWithNil testSetWithSetElement) ].
	
	^ failures! !

!FLBasicSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 12/29/2012 18:04'!
testDateOffsets
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.

	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLBasicSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 12/29/2012 18:07'!
testDateOffsetsChanging
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 1 hours.
	self serialize: object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour
	! !

!GradientFillStyle methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 16:03'!
= anGradientFillStyle
	"Answer whether equal."

	^ self pixelRamp == anGradientFillStyle pixelRamp "LRU should make identity equal"! !

!ClassFactoryForTestCase methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 12/29/2012 16:10'!
newName
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!ClassFactoryForTestCase methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MarianoMartinezPeck 4/19/2012 19:16'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!ClassFactoryForTestCase methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MarianoMartinezPeck 8/7/2012 19:12'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category

	| default newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!ClassFactoryForTestCase methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MarianoMartinezPeck 8/7/2012 19:12'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName

	| default newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!ClassFactoryForTestCase methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MarianoMartinezPeck 4/19/2012 19:23'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!Collection methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:59'!
groupedBy: aBlock
	"Answer a dictionary whose keys are the result of evaluating aBlock
	for all my elements, and the value for each key is the selection of 
	my elements that evaluated to that key. Uses species."
	| groups |
	groups := PluggableDictionary integerDictionary.
	self do: [ :each |
		(groups at: (aBlock value: each) ifAbsentPut: [ OrderedCollection new ]) add: each ].
	self species ~~ OrderedCollection ifTrue: [
		groups associationsDo: [ :association |
			association value: (self species withAll: association value) ]].
	^ groups
! !

!SystemNavigation methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:46'!
allClassesInPackageNamed: packageName
	"Returns the list of classes that belongs to a Monticello package."
	
	"It would be probably better to delegate that query to the package itself"
	| classes organization |
	organization := Smalltalk globals organization.
	classes := ((organization listAtCategoryNamed: packageName) collect: [ :className |
		organization environment at: className ]) asSet.
	(organization categoriesMatching: packageName, '-*') do: [:category| 
		classes addAll: ((organization listAtCategoryNamed: category) collect: [ :className |
		organization environment at: className ]) ].
	^classes asArray! !

!Dictionary class methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:38'!
denseSample
	
	| desiredSize |
	desiredSize := (self new capacity * 0.85) floor.
	^ self new 
		addAll: ((1 to: desiredSize) collect: [ :index | index -> index ]);
		yourself! !

!Dictionary class methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:38'!
sparseSample
	
	| desiredSize |
	desiredSize := (self new capacity * 0.25) floor.
	^ self new 
		addAll:  ((1 to: desiredSize) collect: [ :index | index -> index ]);
		yourself! !

!FLMigrationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 15:59'!
testFormatFixedToVariable
	"Tests that serializer can tolerate a format change from a *fixed* class to *weak/variable*.
	Notice, however, that the other way around (variable to fixed) doesn't work so far"
	
	| materialized |
	self serialize: FLPair new.
	materialized := [ self during: [ self materialized ] rename: FLPair as: FLWeakClassMock ]
		on: AttemptToWriteReadOnlyGlobal
		do: [ :ex | ex resume: true ].
	self assert: materialized size = 0! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 13:09'!
testContext
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 13:09'!
testContextWithClosureAndSender
	"This test should be improved"
	| context1  materializedContext2  context2 |
	
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self.
	
! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 13:09'!
testContextWithNilPc
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 13:09'!
testContextWithSender
	"This test should be improved"
	| context1 context2 materializedContext1 |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	context2 := (MethodContext newForMethod: FLPair >> #method2).
	context2 
		initializeWith: 18 
		stackPtr: 1 
		method: FLPair >> #method2 
		receiver:  (FLPair new right: 5; left: 6) 
		sender: nil.

	context1 privSender:  context2.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 13:09'!
testContextWithTemp
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #methodWithTemp).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #methodWithTemp 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!SmalltalkImage methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 15:01'!
shortImageName
	"Answer the current image name but only that name and not the full path as with imageName."
	"SmalltalkImage current shortImageName"

	^ self imageName copyAfterLast: $/! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 12:27'!
duringTestCompileSilently: code
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 12:15'!
duringTestCompileSilently: code classified: aCategory
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 12:15'!
duringTestCompileSilently: code storeSource: storeSource
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 12:25'!
duringTestCompileSilently: code storeSource: storeSource classified: aCategory
	^ Utilities 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 12:10'!
instanceVariableNamesDo: anUnaryBlock
	"This is part of the interface between the compiler and a class's instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!ClassDescription methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/16/2014 15:55'!
renameSilently: aName
	 [ self rename: aName] fuelValueWithoutNotifications! !

!Environment methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:54'!
associationsDo: aBlock
	bindings associationsDo: aBlock! !

!FLSampleFactory class methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 14:27'!
sampleSelectors	
	^ self methodsInCategory: 'samples'! !

!MethodContext methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 11:56'!
assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]! !

!MethodContext methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 11:49'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender.
	! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 7/19/2014 09:44'!
defaultTimeout
	"We have some long running tests which will be terminated by Squeaks
	implementation of TestCase>>runCase. Increase the default fro 5 to 60 seconds"
	
	^ 60 "seconds"! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 2/26/2013 23:27'!
deleteFileNamed: aFilename
	 FileDirectory default deleteFileNamed: aFilename! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 3/22/2015 12:01'!
newSubclassNamed: nameString of: aClass  instanceVariableNames: ivNamesString classVariableNames: classVarsString
	| class |
	SystemChangeNotifier uniqueInstance doSilently: [
		class := aClass
			subclass: nameString asSymbol
			instanceVariableNames: ivNamesString
			classVariableNames:  classVarsString
			poolDictionaries: ''
			category: self classFactory defaultCategory
	].
	self classFactory createdClasses add: class.
	^ class! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MartinDias 3/1/2013 12:12'!
tearDown
	super tearDown.
	"Traits should be cleaned before classFactory because it seems class factory only knows how to clean classes, not traits."
	self tearDownTraits.
	self tearDownClassFactory.
	self tearDownGlobalVariables.
	self tearDownInstanceVariables! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MartinDias 3/1/2013 12:11'!
tearDownInstanceVariables
	self class withAllSuperclasses do: [ :class |
		class = TestCase ifTrue: [ ^ self ].
		
		class instVarNames do: [ :varName |
			self 
				instVarNamed: varName
				put: nil ] ]! !

!Utilities class methodsFor: '*FuelTestsCompatibilityBeforeSqueak47' stamp: 'MaxLeske 12/29/2012 15:08'!
useAuthor: aString during: aBlock
	| previous |
	previous := AuthorInitials.
	AuthorInitials := aString.
	^ aBlock ensure: [ AuthorInitials := previous ]! !
